// SCI֘A[`
// CxgtOFLGID_SCIgpB
//

#include "kernel.h"
#include "kernel_id.h"
#include "h83664f.h"
#include "h8t_sci.h"

TSCI TSCI3;

static unsigned char hex[16] = "0123456789ABCDEF";


// --------------------------------------------------------
//   VA|[g
// --------------------------------------------------------

void SCI_Init(TSCI *SCI,unsigned char baud) {
	unsigned char dummy;

	*SCI->SMR   = 0x00;						// VA[hWX^: ,8rbg,peB,1rbg
	*SCI->BRR   = baud;						// rbg[gWX^
	*SCI->SCR   = 0x70;						// (TIE),RIE,TE,RE
	dummy       = *SCI->SSR;				// dummy read
	*SCI->SSR   = 0x80;						// Xe[^XNA
	SCI->RXst   = SCI->RXed = 0;			// Mobt@
	SCI->TXst   = SCI->TXed = 0;			// Mobt@
}

// --------------------------------------------------------
//   M荞ݏ
// --------------------------------------------------------

void SCI_RXI(TSCI *SCI) {
	unsigned char ch;
	unsigned char next;

	ch = *SCI->RDR;							// f[^ǂݍ
	*SCI->SSR &= 0xBF;						// VAXe[^XWX^ / MtONA

	// obt@ɃXgA
	next = (SCI->RXed + 1) & (SCIBUFSIZ - 1);
	if (SCI->RXst != next) {
		SCI->RXbuf[SCI->RXed] = ch;
		SCI->RXed = next;
		iset_flg(FLGID_SCI, SCI_FLG_RXINBUF);
	}
}

// --------------------------------------------------------
//   G[荞ݏ
// --------------------------------------------------------

void SCI_ERI(TSCI *SCI) {
	*SCI->SSR &= 0xC7;						// VAXe[^XWX^ / G[tONA
}

// --------------------------------------------------------
//   M荞ݏ
// --------------------------------------------------------

void SCI_TXI(TSCI *SCI) {
	if (SCI->TXst == SCI->TXed) {
		*SCI->SCR &= 0x7F;
		return;
	}

	*SCI->TDR = SCI->TXbuf[SCI->TXst];
	*SCI->SSR &= 0x7F;

	SCI->TXst = (SCI->TXst + 1) & (SCIBUFSIZ - 1);
	if (SCI->TXst == SCI->TXed) {
		clr_flg(FLGID_SCI, SCI_FLG_TXINBUF);
		*SCI->SCR &= 0x7F;
		return;
	}
}


// --------------------------------------------------------
//   荞݃[`
// --------------------------------------------------------

void SCI3_Handler(VP_INT exinf) {
	if (SCI3.SSR.BIT.TDRE != 0)      { SCI_TXI(&TSCI3); }
	if (SCI3.SSR.BIT.RDRF != 0)      { SCI_RXI(&TSCI3); }
	if ((SCI3.SSR.BYTE & 0x38) != 0) { SCI_ERI(&TSCI3); }
}

// --------------------------------------------------------
//   PoCgM
// --------------------------------------------------------

void SCI_putc(TSCI *SCI, unsigned char ch) {
	unsigned char next;

	if ((SCI->TXst == SCI->TXed) && (*SCI->SSR & 0x80)) {
		*SCI->TDR = ch;
		*SCI->SSR &= 0x7f;
		*SCI->SCR &= 0x7f;
	} else {
		next = (SCI->TXed + 1) & (SCIBUFSIZ - 1);
		while(SCI->TXst == next) { dly_tsk(1); }
		SCI->TXbuf[SCI->TXed] = ch;
		SCI->TXed = next;
		set_flg(FLGID_SCI, SCI_FLG_TXINBUF);
		*SCI->SCR |= 0x80;
	}
}


// --------------------------------------------------------
//   MTCY̊mF
// --------------------------------------------------------

int SCI_getlen(TSCI *SCI) {
	int len;

	len = SCI->RXed - SCI->RXst;
	if (len<0) { len += SCIBUFSIZ; }
	return(len);
}

// --------------------------------------------------------
//   PM
// --------------------------------------------------------

int SCI_getc(TSCI *SCI) {
    unsigned char ch;

	if (SCI->RXst == SCI->RXed) {
		return -1;
	} else {
		ch = SCI->RXbuf[SCI->RXst];
		SCI->RXst = (SCI->RXst + 1) & (SCIBUFSIZ - 1);
		if (SCI->RXst == SCI->RXed) { clr_flg(FLGID_SCI, SCI_FLG_RXINBUF); }
	    return ch;
	}
}

// --------------------------------------------------------
//   PM(҂)
// --------------------------------------------------------

int SCI_getcw(TSCI *SCI) {
    unsigned char ch;
	FLGPTN	flg;

	while (SCI->RXst == SCI->RXed) {
		wai_flg(FLGID_SCI, SCI_FLG_RXINBUF, TWF_ORW, &flg);
	}
	ch = SCI->RXbuf[SCI->RXst];
	SCI->RXst = (SCI->RXst + 1) & (SCIBUFSIZ - 1);
	if (SCI->RXst == SCI->RXed) { clr_flg(FLGID_SCI, SCI_FLG_RXINBUF); }
    return ch;
}

// --------------------------------------------------------
//   񑗐M
// --------------------------------------------------------

void SCI_print(TSCI *SCI, unsigned char *str) {
	while (*str != 0) SCI_putc(SCI, *str++);
}

// --------------------------------------------------------
//   16i
// --------------------------------------------------------

void SCI_print_hex(TSCI *SCI, unsigned long l, unsigned int len) {
	while(len>0) {
		SCI_putc(SCI, hex[(l >> ((len-1)*4)) & 15]);
		len--;
	}
}

