// -----------------------------------------------------------------------------
//   ԊORK}V[
// -----------------------------------------------------------------------------
//

#include "kernel.h"					// iTRONwb_t@C
#include "kernel_id.h"				// RtBO[^ɂID`
#include "h83664f.h"				// n[hEFA֘A
#include "h8t_sci.h"				// SCI
#include "h8t_lcd.h"				// LCD
#include "main.h"


static unsigned char			gIR_Mode;
static unsigned int				gIR_LeaderTime1,gIR_LeaderTime2;
static unsigned char			gIR_Data[IR_BUFSIZE];
static unsigned int				gIR_DataPtr,gIR_BitPtr;
static unsigned int				gIR_BitNum,gIR_BitTime;
static unsigned long			gIR_BitTotal;
static unsigned char			gIR_MakerMode;
static unsigned char			gIR_Processing;


// -----------------------------------------------------------------------------
//   X^[gAbv
// -----------------------------------------------------------------------------
int main() {
	sta_hos();	
	return 0;
}


// -----------------------------------------------------------------------------
//   nh
// -----------------------------------------------------------------------------
void Initialize(VP_INT exinf)
{
	// SCI3(19200bps) ----------------------------------------------------
	TSCI3.RDR = &SCI3.RDR;						// SCĨWX^ݒ
	TSCI3.TDR = &SCI3.TDR;
	TSCI3.SMR = &SCI3.SMR.BYTE;
	TSCI3.SCR = &SCI3.SCR3.BYTE;
	TSCI3.SSR = &SCI3.SSR.BYTE;
	TSCI3.BRR = &SCI3.BRR;
	SCI_Init(&TSCI3,SCI_19200);					// 19200bps

	// ̑n[hEFA ------------------------------------------------
	LCD_Initialize();							// LCD
	IO.PCR8				= 0x01;					// LED1o
	IO.PDR8.BYTE		= 0x00;					// LED

	IO.PCR7				= 0x40;					// IR-LED
	IO.PDR7.BYTE		= 0x00;

	IO.PCR1				= 0x00;					// SW.IR-MOD
	IO.PUCR1.BYTE		= 0x20;					// SW->PullUp

	// ^C}Wݒ -------------------------------------------------------------
	TW.TCNT				= 0;
	TW.TMRW.BYTE		= 0x48;
	TW.TCRW.BYTE		= 0x20;					// NbN/4
	TW.TIOR0.BYTE		= 0x06;					// GbWŃCvbgLv`
	TW.TIOR1.BYTE		= 0x00;
	TW.TIERW.BYTE		= 0x81;					// I[o[t[, CvbgLv`AŊ荞
	TW.TSRW.BYTE		= 0;					// 荞ݗvNA
	TW.TMRW.BIT.CTS		= 1;					// JEgX^[g

	// IRRMXe[g --------------------------------------------------
	gIR_Mode			= IRMODE_WAIT_FOR_SIGNAL;
	gIR_Processing		= IRPROCESS_WAITING;

	// ^XNN --------------------------------------------------------------
	act_tsk(TSKID_MAIN);
	act_tsk(TSKID_IRDATA);
}




// -----------------------------------------------------------------------------
//   C^XN
// -----------------------------------------------------------------------------

void MainTask(VP_INT exinf) {
	mbx_ircode_t		*pData;
	int					i;
	unsigned char		Action;


	
	LCD_cls();									// vO\
	LCD_print(0,"Remcon");
	SCI_print(&TSCI3, "Rem-con Commander MainTask started\r\n");

	MB_LED_R = 1;


	// C[v

	while(1) {
		if (rcv_mbx(MBXID_IRRECV, (T_MSG**)&pData) == E_OK) {
			Action = 0;

			SCI_print(&TSCI3, "\r\nMaker    : ");
			SCI_print_hex(&TSCI3, pData->maker, 2);
			SCI_print(&TSCI3, "\r\n");
			SCI_print(&TSCI3, "Leader 1 : ");
			SCI_print_hex(&TSCI3, pData->leaderTime1, 4);
			SCI_print(&TSCI3, "\r\n");
			SCI_print(&TSCI3, "Leader 2 : ");
			SCI_print_hex(&TSCI3, pData->leaderTime2, 4);
			SCI_print(&TSCI3, "\r\n");

			SCI_print(&TSCI3, "BitLength: ");
			SCI_print_hex(&TSCI3, pData->bitTime, 4);
			SCI_print(&TSCI3, "\r\n");

			SCI_print(&TSCI3, "Data     : ");

			for(i=0;i<pData->datalen;i++) {
				SCI_print_hex(&TSCI3, pData->data[i], 2);
				SCI_print(&TSCI3, " ");
			}
			SCI_print(&TSCI3, "\r\n");

			if ((pData->datalen==4) && (pData->data[0]==0x15) && (pData->data[1]==0xEA)) {
				if ((pData->data[2]==0x12) && (pData->data[3]==0xED)) Action = 1;		// erd{^
				if ((pData->data[2]==0x00) && (pData->data[3]==0xFF)) Action = 2;		// ͐ؑ
				if ((pData->data[2]==0x16) && (pData->data[3]==0xE9)) Action = 3;		// ʃAbv
				if ((pData->data[2]==0x17) && (pData->data[3]==0xE8)) Action = 4;		// ʃ_E
			}
			
			rel_mpf(MPFID_IRDATA, (VP *)pData);


			switch(Action) {
			case 1:
				// d{^
				if (get_mpf(MPFID_IRDATA, (VP *)&pData) == E_OK) {
					pData->maker = IRMAKER_OTHER;
					pData->leaderTime1 = 0x3400;
					pData->leaderTime2 = 0x1800;
					pData->bitTime     = 0x0700;
					pData->datalen     = 6;
					pData->data[0]     = 0x14;
					pData->data[1]     = 0x63;
					pData->data[2]     = 0x00;
					pData->data[3]     = 0x84;
					pData->data[4]     = 0x84;
					pData->data[5]     = 0x00;
					if (snd_mbx(MBXID_IRSEND, (T_MSG *)pData) != E_OK) {
						rel_mpf(MPFID_IRDATA, (VP *)pData);
					} else {
						set_flg(FLGID_IRDATA, INTERRUPT_IR_SEND);			// Mset_flgKv
					}
				}
				break;
			case 2:
				// ͐ؑ
				if (get_mpf(MPFID_IRDATA, (VP *)&pData) == E_OK) {
					pData->maker = IRMAKER_OTHER;
					pData->leaderTime1 = 0x3400;
					pData->leaderTime2 = 0x1800;
					pData->bitTime     = 0x0700;
					pData->datalen     = 6;
					pData->data[0]     = 0x14;
					pData->data[1]     = 0x63;
					pData->data[2]     = 0x00;
					pData->data[3]     = 0x84;
					pData->data[4]     = 0x84;
					pData->data[5]     = 0x03;
					if (snd_mbx(MBXID_IRSEND, (T_MSG *)pData) != E_OK) {
						rel_mpf(MPFID_IRDATA, (VP *)pData);
					} else {
						set_flg(FLGID_IRDATA, INTERRUPT_IR_SEND);			// Mset_flgKv
					}
				}
				break;
			case 3:
				// ʃAbv
				if (get_mpf(MPFID_IRDATA, (VP *)&pData) == E_OK) {
					pData->maker = IRMAKER_OTHER;
					pData->leaderTime1 = 0x3400;
					pData->leaderTime2 = 0x1800;
					pData->bitTime     = 0x0700;
					pData->datalen     = 6;
					pData->data[0]     = 0x14;
					pData->data[1]     = 0x63;
					pData->data[2]     = 0x00;
					pData->data[3]     = 0x84;
					pData->data[4]     = 0x84;
					pData->data[5]     = 0x20;
					if (snd_mbx(MBXID_IRSEND, (T_MSG *)pData) != E_OK) {
						rel_mpf(MPFID_IRDATA, (VP *)pData);
					} else {
						set_flg(FLGID_IRDATA, INTERRUPT_IR_SEND);			// Mset_flgKv
					}
				}
				break;
			case 4:
				// ʃ_E
				if (get_mpf(MPFID_IRDATA, (VP *)&pData) == E_OK) {
					pData->maker = IRMAKER_OTHER;
					pData->leaderTime1 = 0x3400;
					pData->leaderTime2 = 0x1800;
					pData->bitTime     = 0x0700;
					pData->datalen     = 6;
					pData->data[0]     = 0x14;
					pData->data[1]     = 0x63;
					pData->data[2]     = 0x00;
					pData->data[3]     = 0x84;
					pData->data[4]     = 0x84;
					pData->data[5]     = 0x21;
					if (snd_mbx(MBXID_IRSEND, (T_MSG *)pData) != E_OK) {
						rel_mpf(MPFID_IRDATA, (VP *)pData);
					} else {
						set_flg(FLGID_IRDATA, INTERRUPT_IR_SEND);			// Mset_flgKv
					}
				}
				break;
			}
		}
	}
}





// -----------------------------------------------------------------------------
//   RR[h^XN
// -----------------------------------------------------------------------------

// --------------------------------------
//   RR[hM^XN
// --------------------------------------

void IRInterruptTask(VP_INT exinf) {
	FLGPTN					flg;
	int 					i,j;
	mbx_ircode_t 			*pData;

	while(1) {
		// 荞ݑ҂
		wai_flg(FLGID_IRDATA, INTERRUPT_IR_RECV | INTERRUPT_IR_SEND, TWF_ORW, &flg);
		if ((flg & INTERRUPT_IR_RECV) != 0) {
			if (gIR_MakerMode != IRMAKER_UNKNOWN) {
				if (get_mpf(MPFID_IRDATA, (VP *)&pData) != E_OK) {
					SCI_print(&TSCI3,"IRInterruptTask : Error!\r\n");
				} else {
					pData->maker = gIR_MakerMode;
					pData->leaderTime1 = gIR_LeaderTime1;
					pData->leaderTime2 = gIR_LeaderTime2;
					pData->bitTime     = gIR_BitTime;
					pData->datalen     = gIR_DataPtr;
					for(i=0;i<gIR_DataPtr;i++) pData->data[i] = gIR_Data[i];

					if (snd_mbx(MBXID_IRRECV, (T_MSG *)pData) != E_OK) {
						rel_mpf(MPFID_IRDATA, (VP *)pData);
					}
				}
			}
		}
		if ((flg & INTERRUPT_IR_SEND) != 0) {
			if (prcv_mbx(MBXID_IRSEND, (T_MSG**)&pData) == E_OK) {
				// M[h֐؂ւ
				TW.TIERW.BYTE		= 0;					// 荞ݒ~
				TW.TMRW.BIT.CTS		= 0;					// JEgXgbv
				TW.TIOR0.BYTE		= 0x00;					// AEgvbgRyA[h
				TW.TCNT				= 0;
				TW.TSRW.BYTE		= 0;					// 荞ݗvNA
				gIR_Processing		= IRPROCESS_SENDING;

				// [_M
				TW.GRA				= pData->leaderTime1;
				TW.TIERW.BYTE		= 0x81;					// I[o[t[, AEgvbgRyAAŊ荞
				TW.TMRW.BIT.CTS		= 1;					// JEgX^[g

				// 38KHz IR/ON
				TV.TCNTV = 0;
				TV.TCORA = 52;		// 105*4 = 420  38KHz*420=15.96MHz
				TV.TCORB = 105;
				TV.TCRV0.BYTE = 0x11;	// /4, RyA}b`BŃNA
				TV.TCSRV.BYTE = 0x06;	// RyA}b`A1, RyA}b`B0
				TV.TCRV1.BYTE = 0x00;
				wai_flg(FLGID_IRDATA, INTERRUPT_IR_SENDNEXT, TWF_ORW, &flg);	// ^C~O҂

				if (pData->maker != IRMAKER_SONY) {
					TV.TCRV0.BYTE = 0x10;	// IR/OFF
					MB_LED_IR = 0;
					TW.GRA			= pData->leaderTime2;
					wai_flg(FLGID_IRDATA, INTERRUPT_IR_SENDNEXT, TWF_ORW, &flg);	// ^C~O҂
				}

				// rbg
				for(i=0;i<pData->datalen;i++) {
					for(j=0;j<8;j++) {
						if (pData->maker == IRMAKER_SONY) {
							TV.TCRV0.BYTE = 0x10;	// IR/OFF
							MB_LED_IR = 0;
						} else {
							TV.TCRV0.BYTE = 0x11;	// IR/ON
						}
						TW.GRA			= pData->bitTime;
						wai_flg(FLGID_IRDATA, INTERRUPT_IR_SENDNEXT, TWF_ORW, &flg);	// ^C~O҂

						if (pData->maker == IRMAKER_SONY) {
							TV.TCRV0.BYTE = 0x11;	// IR/ON
						} else {
							TV.TCRV0.BYTE = 0x10;	// IR/OFF
							MB_LED_IR = 0;
						}
						if ((pData->data[i] & 0x01) == 0) {
							TW.GRA			= pData->bitTime;			// 0
						} else {
							TW.GRA			= pData->bitTime * 3;		// 1
						}
						pData->data[i] = pData->data[i] >> 1;
						wai_flg(FLGID_IRDATA, INTERRUPT_IR_SENDNEXT, TWF_ORW, &flg);	// ^C~O҂
					}
				}
				if (pData->maker == IRMAKER_SONY) {
					TV.TCRV0.BYTE = 0x10;	// IR/OFF
					MB_LED_IR = 0;
				} else {
					TV.TCRV0.BYTE = 0x11;	// IR/ON
					TW.GRA			= pData->bitTime;
					wai_flg(FLGID_IRDATA, INTERRUPT_IR_SENDNEXT, TWF_ORW, &flg);	// ^C~O҂
					TV.TCRV0.BYTE = 0x10;	// IR/OFF
					MB_LED_IR = 0;
				}

				rel_mpf(MPFID_IRDATA, (VP *)pData);

				// Mҋ@Ԃ֕A
				gIR_Processing = IRPROCESS_WAITING;
				gIR_Mode = IRMODE_WAIT_FOR_SIGNAL;
				TW.TIOR0.BYTE		= 0x06;					// GbWŃCvbgLv`
			}
		}

		gIR_Processing = IRPROCESS_WAITING;
	}
}


// -------------------------------------------
//   RR[hM荞݁i^C}Wj
// -------------------------------------------

void IrRemote_Interrupt(VP_INT exinf) {
	unsigned char			bState;
	unsigned int			nTime;

	// ----------------------------------------------------------
	//   M荞ݏ
	// ----------------------------------------------------------
	if ((TW.TSRW.BIT.IMFA == 1) && ((gIR_Processing == IRPROCESS_WAITING) || (gIR_Processing == IRPROCESS_RECIEVING))) {
		// CvbgLv`AiԊOɕωj
		TW.TCNT				= 0;		// JE^NA
		bState				= MB_IR;	// ݂̏Ԃۑ
		nTime				= TW.GRA;	// ̃JE^

		switch(gIR_Mode) {

			// M҂ԂMm烊[_胂[h
		case IRMODE_WAIT_FOR_SIGNAL:
			if (bState == 0) {
				gIR_Mode = IRMODE_ERROR;
			} else {
				gIR_Mode = IRMODE_LEADER_FIRST;
			}
			break;

			// [_聨L^Ď
		case IRMODE_LEADER_FIRST:
			if (bState == 1) {
				gIR_Mode = IRMODE_ERROR;
			} else {
				if (nTime > IR_MINLEADERLENGTH) {
					gIR_Mode = IRMODE_LEADER_NEXT;
					gIR_LeaderTime1 = nTime;
				} else {
					gIR_Mode = IRMODE_ERROR;
				}
			}
			break;

			// [_L^ărbg̏
		case IRMODE_LEADER_NEXT:
			if (bState == 0) {
				gIR_Mode = IRMODE_ERROR;
			} else {
				gIR_Mode = IRMODE_BIT_1;
				gIR_LeaderTime2 = nTime;
				gIR_BitTime = 0;
				gIR_BitNum = 0;
				gIR_BitTotal = 0;
				gIR_DataPtr = 0;
				gIR_Data[gIR_DataPtr] = 0;
				gIR_BitPtr = 0;
				gIR_MakerMode = IRMAKER_UNKNOWN;
			}
			break;

			// rbgM"1"PʎԂL^
		case IRMODE_BIT_1:
			if (bState == 1) {
				gIR_Mode = IRMODE_ERROR;
			} else {
				if (nTime > gIR_LeaderTime1) {
					// ̎Ԃ[_Ԃ蒷R[hI
					gIR_Mode = IRMODE_COMPLETED;
					if (gIR_BitPtr != 0) { gIR_DataPtr++; }
					gIR_Processing = IRPROCESS_DATAPROCESS;
					iset_flg(FLGID_IRDATA, INTERRUPT_IR_RECV);
				} else {
					// rbgԂƐł̂Ńrbg
					gIR_Mode = IRMODE_BIT_NEXT;

					if (gIR_BitNum == 0) {
						// ŏ̑Ȃ炻̂܂܋L^
						gIR_BitTime = nTime;
						gIR_BitNum++;
						gIR_BitTotal += nTime;
					} else {
						if (gIR_MakerMode == IRMAKER_SONY) {
							// SONY^CvRR[h : f[^
							// rbgԂ1.5{Z΃rbg0, ΃rbg1
							if ((gIR_BitTime + (gIR_BitTime>>1)) > nTime) {
								gIR_Data[gIR_DataPtr] = (gIR_Data[gIR_DataPtr] >> 1);
							} else {
								gIR_Data[gIR_DataPtr] = (gIR_Data[gIR_DataPtr] >> 1) + 0x80;
							}
							gIR_BitPtr++;

							if (gIR_BitPtr == 8) {
								gIR_BitPtr = 0;
								gIR_DataPtr++;
								if (gIR_DataPtr == IR_BUFSIZE) {
									gIR_Mode = IRMODE_ERROR;
								} else {
									gIR_Data[gIR_DataPtr] = 0;
								}
							}
						} else {
							// ʃRR[h : rbgԑ
							// ŏ̑ȊOȂA͂ꂷĂȂǂ`FbN
							if (((gIR_BitTime >> 1) > nTime) || ((gIR_BitTime << 1) < nTime)) {
								gIR_Mode = IRMODE_ERROR;
							} else {
								// ͂ĂȂ畽ωĂ
								gIR_BitNum++;
								gIR_BitTotal += nTime;
								gIR_BitTime = gIR_BitTotal / gIR_BitNum;
							}
						}
					}
				}
			}
			break;

			// rbgM"0"rbg肵ċL^
		case IRMODE_BIT_NEXT:
			if (bState == 0) {
				gIR_Mode = IRMODE_ERROR;
			} else {
				if (nTime > gIR_LeaderTime1) {
					// ̎Ԃ[_Ԃ蒷R[hI
					gIR_Mode = IRMODE_COMPLETED;
					if (gIR_BitPtr != 0) { gIR_DataPtr++; }
					gIR_Processing = IRPROCESS_DATAPROCESS;
					iset_flg(FLGID_IRDATA, INTERRUPT_IR_RECV);
				} else {
					// rbgԂƐł̂Ńrbg
					gIR_Mode = IRMODE_BIT_1;

					// [J[[h܂Ȃ̂Ŕ菈s
					if (gIR_MakerMode == IRMAKER_UNKNOWN) {
						if (((gIR_LeaderTime2 >> 1) < nTime) && ((gIR_LeaderTime2 << 1) > nTime)) {
							// [_IԂƍ̎ԂقړSONYR[h^CvƂ݂Ȃčď
							gIR_MakerMode = IRMAKER_SONY;
							// Eŏ̑̎BitTimeFirstf[^
							// EgIR_LeaderTime2nTimegIR_BitTimeɑ
							// rbgԂ1.5{Z΃rbg0, ΃rbg1
							if ((gIR_LeaderTime2 + (gIR_LeaderTime2 >> 1)) > gIR_BitTime) {
								gIR_Data[gIR_DataPtr] = (gIR_Data[gIR_DataPtr] >> 1);
							} else {
								gIR_Data[gIR_DataPtr] = (gIR_Data[gIR_DataPtr] >> 1) + 0x80;
							}
							gIR_BitPtr++;

							// f[^
							gIR_BitTime     = gIR_LeaderTime2;
							gIR_BitNum      = 1;
							gIR_BitTotal    = gIR_LeaderTime2;
							gIR_LeaderTime2 = 0;
						} else {
							// ʓIȃR䃂[h
							gIR_MakerMode = IRMAKER_OTHER;
						}
					}

					// rbg
					if (gIR_MakerMode == IRMAKER_SONY) {
						// SONY^CvRR[h : rbgԑ
						// rbg
						if (((gIR_BitTime >> 1) > nTime) || ((gIR_BitTime << 1) < nTime)) {
							gIR_Mode = IRMODE_ERROR;
						} else {
							// ͂ĂȂ畽ωĂ
							gIR_BitNum++;
							gIR_BitTotal += nTime;
							gIR_BitTime = gIR_BitTotal / gIR_BitNum;
						}
					} else {
						// ʃRR[h : f[^
						// rbgԂ̂Q{Z΃rbg0, ΃rbg1
						if ((gIR_BitTime << 1) > nTime) {
							gIR_Data[gIR_DataPtr] = (gIR_Data[gIR_DataPtr] >> 1);
						} else {
							gIR_Data[gIR_DataPtr] = (gIR_Data[gIR_DataPtr] >> 1) + 0x80;
						}
						gIR_BitPtr++;

						if (gIR_BitPtr == 8) {
							gIR_BitPtr = 0;
							gIR_DataPtr++;
							if (gIR_DataPtr == IR_BUFSIZE) {
								gIR_Mode = IRMODE_ERROR;
							} else {
								gIR_Data[gIR_DataPtr] = 0;
							}
						}
					}
				}
			}
			break;
		}
	}


	// ----------------------------------------------------------
	//   I[o[t[荞ݏ
	// ----------------------------------------------------------
	if ((TW.TSRW.BIT.OVF == 1) && ((gIR_Processing == IRPROCESS_WAITING) || (gIR_Processing == IRPROCESS_RECIEVING))) {
		// I[o[t[
		switch(gIR_Mode) {

		case IRMODE_ERROR:
		case IRMODE_COMPLETED:
			// O̎MG[ςȂ΃VOi҂ԂɈڍs邾
			gIR_Mode = IRMODE_WAIT_FOR_SIGNAL;
			break;

		case IRMODE_BIT_1:
		case IRMODE_BIT_NEXT:
			// O̎MrbgȂΏ
			gIR_Mode = IRMODE_WAIT_FOR_SIGNAL;
			if (gIR_BitPtr != 0) { gIR_DataPtr++; }
			gIR_Processing = IRPROCESS_DATAPROCESS;
			iset_flg(FLGID_IRDATA, INTERRUPT_IR_RECV);
			break;

		default:
			gIR_Mode = IRMODE_WAIT_FOR_SIGNAL;
			break;
		}
	}

	
	// ----------------------------------------------------------
	//   M^C~O荞ݏ
	// ----------------------------------------------------------
	if ((TW.TSRW.BIT.IMFA == 1) && (gIR_Processing == IRPROCESS_SENDING)) {
		TW.TCNT				= 0;		// JE^NA
		iset_flg(FLGID_IRDATA, INTERRUPT_IR_SENDNEXT);
	}

	TW.TSRW.BYTE = 0;	// 荞ݗvNA
}


